<template>
  <q-card
    :square="!isDesktopPlatform"
    :class="{ 'edit-form-desktop': isDesktopPlatform, 'edit-form-mobile': !isDesktopPlatform }"
  >
    <q-form @submit="onSubmit">
      <q-card-section>
        <MonthSelectorInput
          v-model="month"
          :label="$gettext('Application month')"
          :error="!isMonthAvailable"
          :error-message="$gettext('This month is already used')"
        />

        <q-input
          v-model.number="storedMonths"
          :label="$gettext('Manure amount in number of months')"
          step="1"
          filled
          type="number"
          :min="1"
          :rules="[ val => val > 0 || $gettext('This value must be positive')]"
          class="q-mt-md"
        />
      </q-card-section>

      <q-card-actions align="right">
        <q-btn
          :label="$gettext('Cancel')"
          flat
          @click="onCancel"
        />
        <q-btn
          :label="$gettext('Remove')"
          flat
          color="red"
          @click="onDelete"
          v-if="!isNew"
        />
        <q-btn
          :label="saveButtonLabel"
          flat
          color="primary"
          type="submit"
          :disable="!canSubmit"
        />
      </q-card-actions>
    </q-form>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import MonthSelectorInput from 'src/components/form/MonthSelectorInput'

export default {
  name: 'IcpaPmnManureApplicationEditForm',
  components: {
    MonthSelectorInput
  },
  mixins: [
    PlatformMixin
  ],
  props: {
    id: {
      type: Number,
      default: null
    },
    initialMonth: {
      type: Object,
      default: null
    },
    initialStoredMonths: {
      type: Number,
      default: null
    },
    existingItems: {
      type: Array,
      required: true
    }
  },
  emits: ['save', 'cancel', 'delete'],
  data () {
    return {
      month: this.initialMonth,
      storedMonths: this.initialStoredMonths
    }
  },
  computed: {
    isNew () {
      return !this.id
    },
    saveButtonLabel () {
      return this.isNew ? this.$gettext('Add') : this.$gettext('Update')
    },
    canSubmit () {
      return this.month && this.isMonthAvailable && this.storedMonths
    },
    isMonthAvailable () {
      return !this.month || (this.month.id === this.initialMonth?.id || !this.existingItems.find(item => item.month.id === this.month.id))
    }
  },
  methods: {
    onSubmit () {
      if (this.canSubmit) {
        this.$emit('save', {
          id: this.id,
          month: this.month,
          storedMonths: Number(this.storedMonths)
        })
      }
    },
    onCancel () {
      this.$emit('cancel')
    },
    onDelete () {
      this.$emit('delete', this.id)
    }
  }
}
</script>

<style scoped>
.edit-form-desktop {
  min-width: 500px;
}
.edit-form-mobile {
  width: 100%;
}
</style>
